// prepreka
// s semaforji:
//   spremenljivka threads je lahko uporabljena večkrat, saj jo resetiramo preden spustimo vse niti naprej
//   ponovno lahko uporabimo tudi semafor counter
//   težava je v semaforju block (ne uspe mi je povzročiti)
//     situacija: imamo dve nitki, nit 0 se je zataknila pred sem_wait(&block), nit 1 naredi vse sem_post(&block) in 
//     začne drugi cikel, kjer pride do sem_wait(&block) ter ga preskoči, saj je še vedno na voljo 
//	   sem_post namenjen niti 0 ...  tipično tvegano stanje


#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <Windows.h>

#define	NTHREADS	10
#define NPRINTS		10

int threads;
int shared;

sem_t counter, block;

void* barrier(void* arg) 
{
	int i, j;
	int myid = (int)arg;	

	for(i=0; i<NPRINTS; i++)
	{
		if( myid == 0 )
			shared++;

		// prepreka - zacetek
		sem_wait(&counter);
		if( threads < NTHREADS-1 )
		{
			threads++;
			sem_post(&counter);
			sem_wait(&block);
		}
		else
		{
			threads = 0;
			sem_post(&counter);
			for( j=0; j<NTHREADS-1; j++)
				sem_post(&block);
		}
		// prepreka - konec

		printf("Nit %d: vrednost: %d\n", myid, shared);
	}

	return NULL;
}

int main(int argc, char *argv[]) 
{
	int i;
	pthread_t t[NTHREADS];

	shared = 0;

	sem_init(&counter, 0, 1);
	sem_init(&block, 0, 0);

	for(i=0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, barrier, (void *)i);

	for(i=0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	sem_destroy(&counter);
	sem_destroy(&block);

	return 0;
}
